import javax.swing.*;
import java.io.*;
import java.net.URL;
import java.net.URLConnection;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import javax.swing.filechooser.*;

/**
 * Редактор свойств для java
 * решает проблему определения utf-8
 * кодировки(русский пишем в кодах,типа: /u001)
 */
public class app extends JFrame
{
	private JToolBar tools=null;

	PropsTableModel propsTableModel=new PropsTableModel();
	OpenAction openAction=new OpenAction();
	StoreAction storeAction=new StoreAction();
	AddAction addAction=new AddAction();
	DeleteAction deleteAction=new DeleteAction();
	JButton openButton=null;
	JButton storeButton=null;
	JButton addButton=null;
	JButton deleteButton=null;
	JTable table=new JTable();
	private void initTable()
	{
	    
	    this.propsTableModel.setTable(table);
	      table.setFillsViewportHeight(true);
table.setAutoCreateRowSorter(true);
		 JScrollPane scrollPane = new JScrollPane(table);
         add(scrollPane,BorderLayout.PAGE_START);
         

	}
	private JButton getOpenButton()
	{
		openAction.setModel(propsTableModel);
		openButton=new JButton(openAction);
		return openButton;
	}
	private JButton getAddButton()
	{
		addAction.setModel(propsTableModel);
		addButton=new JButton(addAction);
		return addButton;
	}
	private JButton getDeleteButton()
	{
		deleteAction.setModel(propsTableModel);
		deleteButton=new JButton(deleteAction);
		return deleteButton;
	}
	private JButton getStoreButton()
	{
		storeAction.setModel(propsTableModel);
		storeButton=new JButton(storeAction);
		return storeButton;
	}
	public JToolBar getTools()
	{
		if(tools==null)
		{
			tools=new JToolBar();
			tools.add(getOpenButton());
			tools.add(getStoreButton());
			tools.add(getAddButton());
			tools.add(getDeleteButton());
		}
		return tools;
	}
	
	public app()
	{
		super("properties-editor");
		setSize(640,480);
		setLocationRelativeTo(null);
		setLayout(new BorderLayout());
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		     add(getTools(), BorderLayout.PAGE_END);
		     initTable();

	}
	 public static void main(String[] args)
	 {
		 SwingUtilities.invokeLater(new Runnable()
		 {
			 public void run()
			 {
				 app frame=new app();
				 frame.setVisible(true);
			 }
		 });
	 }
}
class PropsTableModel extends AbstractTableModel {
    private String[] columnNames = {"key","value"};
    private Properties data = new Properties();
    private JTable table=null;
    

    public void setTable(JTable table)
    {
		this.table=table;
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		table.setModel(this);
			//	table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			final int width=640/3;
			//System.err.println(width);
		table.getColumnModel().getColumn(0).setPreferredWidth(width);
		table.getColumnModel().getColumn(0).setMinWidth(width);
		table.getColumnModel().getColumn(0).setMaxWidth(width);
	table.setAutoResizeMode(JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS);
	
        
	}
    public void loadData()
    {
		JFileChooser fc=new JFileChooser();
		fc.setDialogTitle("Open");
		fc.setDialogType(JFileChooser.OPEN_DIALOG );
		 int returnVal = fc.showOpenDialog(null);
		 if (returnVal != JFileChooser.APPROVE_OPTION) return;

		try{
FileInputStream in = new FileInputStream(fc.getSelectedFile());
data.load(in);
in.close();}catch(Exception e) {e.printStackTrace();}

fireTableDataChanged();

}
public void add()
{
	data.setProperty("newproperties"+java.lang.System.nanoTime(),"n/a");
	fireTableDataChanged();
}
public void delete()
{
	int[] selection = table.getSelectedRows();
   for (int i = 0; i < selection.length; i++) {
     selection[i] = table.convertRowIndexToModel(selection[i]);
     String key=(String)data.keySet().toArray()[selection[i]];
	 data.remove(key);
   }
  
	fireTableDataChanged();
}
public void storeData()
    {
	    JFileChooser fc=new JFileChooser();
		fc.setApproveButtonText("Save");
		fc.setDialogTitle("Save");
		fc.setDialogType(JFileChooser.SAVE_DIALOG);
		
		int returnVal = fc.showSaveDialog(null);
		 if (returnVal != JFileChooser.APPROVE_OPTION) return;
		try{

data.store(new FileOutputStream(fc.getSelectedFile()),"");
}catch(Exception e) {e.printStackTrace();}


}
public int getColumnCount() {
        return columnNames.length;
    }
 public String getColumnName(int col) {
        return columnNames[col];
    }
   public Object getValueAt(int row, int col) 
   {
	   if(col==0)
        return data.keySet().toArray()[row];
        else
         return data.getProperty((String)data.keySet().toArray()[row]);
    }


 public int getRowCount() {
        return data.size();
    }

 public boolean isCellEditable(int row, int col) 
 {
	 return true;
 }
 public void setValueAt(Object value, int row, int col)
   {
	   String key=(String)data.keySet().toArray()[row];
	   String val="";
	   
        if(col==0){
			val=data.getProperty(key);
         data.remove(key);
         data.put(value.toString(),val);
        }
        if(col==1)
        {
			data.setProperty(key,value.toString());
		}
		fireTableDataChanged();
   }

}
class OpenAction extends AbstractAction 
{
	private PropsTableModel propsTableModel=null;
    public void setModel(PropsTableModel propsTableModel)
    {
		 this.propsTableModel=propsTableModel;
	}
    public OpenAction() {
      super("Open...");
      
    }
     
    public void actionPerformed(ActionEvent e) {
	this.propsTableModel.loadData();
	
	}
}

class StoreAction extends AbstractAction 
{
	private PropsTableModel propsTableModel=null;
    public void setModel(PropsTableModel propsTableModel)
    {
		 this.propsTableModel=propsTableModel;
	}
    public StoreAction() {
      super("Save...");
      
    }
     
    public void actionPerformed(ActionEvent e) {
	this.propsTableModel.storeData();
	}
}
class AddAction extends AbstractAction 
{
	private PropsTableModel propsTableModel=null;
    public void setModel(PropsTableModel propsTableModel)
    {
		 this.propsTableModel=propsTableModel;
	}
    public AddAction() {
      super("Add Key");
      
    }
     
    public void actionPerformed(ActionEvent e) {
	this.propsTableModel.add();
	}
}
class DeleteAction extends AbstractAction 
{
	private PropsTableModel propsTableModel=null;
    public void setModel(PropsTableModel propsTableModel)
    {
		 this.propsTableModel=propsTableModel;
	}
    public DeleteAction() {
      super("Delete Key");
      
    }
     
    public void actionPerformed(ActionEvent e) {
	this.propsTableModel.delete();
	}
}

